Orxonox: orxonox::MultiType::MT_ValueBase Class Reference

# orxonox::MultiType::MT_ValueBase Class Reference

MT_ValueBase is an almost pure virtual baseclass of MT_Value<T>, which holds the value of the MultiType. This class is only used within the MultiType. More...

`#include <src/util/MultiType.h>`

Inheritance diagram for orxonox::MultiType::MT_ValueBase:

List of all members.

## Public Member Functions

virtual bool | assimilate (const MultiType &other)=0
virtual MT_ValueBase * | clone () const =0
virtual void | exportData (uint8_t *&mem) const =0
virtual uint8_t | getSize () const =0
const MT_Type::Value & | getType () const
| Returns the type of the current value.
virtual bool | getValue (orxonox::Degree *value) const =0
virtual bool | getValue (orxonox::Radian *value) const =0
virtual bool | getValue (orxonox::Quaternion *value) const =0
virtual bool | getValue (orxonox::ColourValue *value) const =0
virtual bool | getValue (orxonox::Vector4 *value) const =0
virtual bool | getValue (orxonox::Vector3 *value) const =0
virtual bool | getValue (orxonox::Vector2 *value) const =0
virtual bool | getValue (std::string *value) const =0
virtual bool | getValue (void **value) const =0
virtual bool | getValue (bool *value) const =0
virtual bool | getValue (long double *value) const =0
virtual bool | getValue (double *value) const =0
virtual bool | getValue (float *value) const =0
virtual bool | getValue (unsigned long long *value) const =0
virtual bool | getValue (long long *value) const =0
virtual bool | getValue (unsigned long *value) const =0
virtual bool | getValue (long *value) const =0
virtual bool | getValue (unsigned int *value) const =0
virtual bool | getValue (int *value) const =0
virtual bool | getValue (unsigned short *value) const =0
virtual bool | getValue (short *value) const =0
virtual bool | getValue (unsigned char *value) const =0
virtual bool | getValue (char *value) const =0
bool | hasDefaultValue () const
| Checks whether the value is a default one.
virtual void | importData (uint8_t *&mem)=0
| MT_ValueBase (MT_Type::Value type)
virtual | operator bool () const =0
virtual | operator char () const =0
virtual | operator double () const =0
virtual | operator float () const =0
virtual | operator int () const =0
virtual | operator long () const =0
virtual | operator long double () const =0
virtual | operator long long () const =0
virtual | operator orxonox::ColourValue () const =0
virtual | operator orxonox::Degree () const =0
virtual | operator orxonox::Quaternion () const =0
virtual | operator orxonox::Radian () const =0
virtual | operator orxonox::Vector2 () const =0
virtual | operator orxonox::Vector3 () const =0
virtual | operator orxonox::Vector4 () const =0
virtual | operator short () const =0
virtual | operator std::string () const =0
virtual | operator unsigned char () const =0
virtual | operator unsigned int () const =0
virtual | operator unsigned long () const =0
virtual | operator unsigned long long () const =0
virtual | operator unsigned short () const =0
virtual | operator void * () const =0
virtual void | reset ()=0
virtual bool | setValue (const orxonox::Degree &value)=0
virtual bool | setValue (const orxonox::Radian &value)=0
virtual bool | setValue (const orxonox::Quaternion &value)=0
virtual bool | setValue (const orxonox::ColourValue &value)=0
virtual bool | setValue (const orxonox::Vector4 &value)=0
virtual bool | setValue (const orxonox::Vector3 &value)=0
virtual bool | setValue (const orxonox::Vector2 &value)=0
virtual bool | setValue (const std::string &value)=0
virtual bool | setValue (void *const &value)=0
virtual bool | setValue (const bool &value)=0
virtual bool | setValue (const long double &value)=0
virtual bool | setValue (const double &value)=0
virtual bool | setValue (const float &value)=0
virtual bool | setValue (const unsigned long long &value)=0
virtual bool | setValue (const long long &value)=0
virtual bool | setValue (const unsigned long &value)=0
virtual bool | setValue (const long &value)=0
virtual bool | setValue (const unsigned int &value)=0
virtual bool | setValue (const int &value)=0
virtual bool | setValue (const unsigned short &value)=0
virtual bool | setValue (const short &value)=0
virtual bool | setValue (const unsigned char &value)=0
virtual bool | setValue (const char &value)=0
virtual void | toString (std::ostream &outstream) const =0
virtual | ~MT_ValueBase ()

## Public Attributes

bool | bHasDefaultValue_
| True if the last conversion wasn't successful.
MT_Type::Value | type_
| The type of the current value.

## Detailed Description

MT_ValueBase is an almost pure virtual baseclass of MT_Value<T>, which holds the value of the MultiType. This class is only used within the MultiType.

## Constructor & Destructor Documentation

orxonox::MultiType::MT_ValueBase::MT_ValueBase | ( | MT_Type::Value | type | ) | `[inline]`

virtual orxonox::MultiType::MT_ValueBase::~MT_ValueBase | ( |  | ) | `[inline, virtual]`

## Member Function Documentation

virtual bool orxonox::MultiType::MT_ValueBase::assimilate | ( | const MultiType & | other | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual MT_ValueBase* orxonox::MultiType::MT_ValueBase::clone | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

Referenced by orxonox::MultiType::copy(), and orxonox::MultiType::setValue().

virtual void orxonox::MultiType::MT_ValueBase::exportData | ( | uint8_t *& | mem | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >, orxonox::MT_Value< T >, orxonox::MT_Value< T >, orxonox::MT_Value< T >, orxonox::MT_Value< T >, orxonox::MT_Value< T >, and orxonox::MT_Value< T >.

virtual uint8_t orxonox::MultiType::MT_ValueBase::getSize | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >, orxonox::MT_Value< T >, orxonox::MT_Value< T >, orxonox::MT_Value< T >, orxonox::MT_Value< T >, orxonox::MT_Value< T >, and orxonox::MT_Value< T >.

const MT_Type::Value& orxonox::MultiType::MT_ValueBase::getType | ( |  | ) | const`[inline]`

Returns the type of the current value.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | orxonox::Degree * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | orxonox::Radian * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | orxonox::Quaternion * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | orxonox::ColourValue * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | orxonox::Vector4 * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | orxonox::Vector3 * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | orxonox::Vector2 * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | std::string * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | void ** | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | bool * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | long double * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | double * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | float * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | unsigned long long * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | long long * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | unsigned long * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | long * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | unsigned int * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | int * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | unsigned short * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | short * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | unsigned char * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::getValue | ( | char * | value | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

bool orxonox::MultiType::MT_ValueBase::hasDefaultValue | ( |  | ) | const`[inline]`

Checks whether the value is a default one.

virtual void orxonox::MultiType::MT_ValueBase::importData | ( | uint8_t *& | mem | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >, orxonox::MT_Value< T >, orxonox::MT_Value< T >, orxonox::MT_Value< T >, orxonox::MT_Value< T >, orxonox::MT_Value< T >, and orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator bool | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator char | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator double | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator float | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator int | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator long | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator long double | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator long long | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator orxonox::ColourValue | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator orxonox::Degree | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator orxonox::Quaternion | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator orxonox::Radian | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator orxonox::Vector2 | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator orxonox::Vector3 | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator orxonox::Vector4 | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator short | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator std::string | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator unsigned char | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator unsigned int | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator unsigned long | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator unsigned long long | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator unsigned short | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual orxonox::MultiType::MT_ValueBase::operator void * | ( |  | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual void orxonox::MultiType::MT_ValueBase::reset | ( |  | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const orxonox::Degree & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const orxonox::Radian & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const orxonox::Quaternion & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const orxonox::ColourValue & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const orxonox::Vector4 & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const orxonox::Vector3 & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const orxonox::Vector2 & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const std::string & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | void *const & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const bool & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const long double & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const double & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const float & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const unsigned long long & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const long long & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const unsigned long & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const long & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const unsigned int & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const int & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const unsigned short & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const short & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const unsigned char & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

virtual bool orxonox::MultiType::MT_ValueBase::setValue | ( | const char & | value | ) | `[pure virtual]`

Implemented in orxonox::MT_Value< T >.

Referenced by orxonox::MultiType::setValue().

virtual void orxonox::MultiType::MT_ValueBase::toString | ( | std::ostream & | outstream | ) | const`[pure virtual]`

Implemented in orxonox::MT_Value< T >.

## Member Data Documentation

bool orxonox::MultiType::MT_ValueBase::bHasDefaultValue_

True if the last conversion wasn't successful.

Referenced by orxonox::MT_Value< T >::assimilate(), orxonox::MT_Value< T >::reset(), and orxonox::MT_Value< T >::setValue().

MT_Type::Value orxonox::MultiType::MT_ValueBase::type_

The type of the current value.

Referenced by orxonox::MT_Value< T >::clone(), orxonox::MultiType::getTypename(), orxonox::MultiType::operator bool(), orxonox::MultiType::operator char(), orxonox::MultiType::operator double(), orxonox::MultiType::operator float(), orxonox::MultiType::operator int(), orxonox::MultiType::operator long(), orxonox::MultiType::operator long double(), orxonox::MultiType::operator long long(), orxonox::MultiType::operator orxonox::ColourValue(), orxonox::MultiType::operator orxonox::Degree(), orxonox::MultiType::operator orxonox::Quaternion(), orxonox::MultiType::operator orxonox::Radian(), orxonox::MultiType::operator orxonox::Vector2(), orxonox::MultiType::operator orxonox::Vector3(), orxonox::MultiType::operator orxonox::Vector4(), orxonox::MultiType::operator short(), orxonox::MultiType::operator std::string(), orxonox::MultiType::operator unsigned char(), orxonox::MultiType::operator unsigned int(), orxonox::MultiType::operator unsigned long(), orxonox::MultiType::operator unsigned long long(), orxonox::MultiType::operator unsigned short(), and orxonox::MultiType::operator void *().

The documentation for this class was generated from the following file:

- src/util/MultiType.h